Sub Main

	Set comps = ActiveDocument.ActiveSheet.Components 
	Debug.Print "components found: " & comps.Count

	Dim this_name As String

	For i = 1 To comps.Count Step 1
		this_name = comps.Item(i).Name
		Debug.Print "original name: " & this_name
		
		new_ref_num = LTrim(Str(Val(Mid(this_name,2,4))+9000))
		new_name = Mid(this_name,1,1) & new_ref_num
		
		Debug.Print "new name:" & new_name
		
		Let comps.Item(i).Name = new_name
			
	Next i

	Dim rcount As Integer
	Dim ccount As Integer
	Dim ucount As Integer
	Dim lcount As Integer
	Dim the_count As Integer
	Dim dcount As Integer
	
	dcount = rcount = ccount = ucount = lcount = 1
		
	For i = 1 To comps.Count Step 1
	
		this_name = comps.Item(i).Name
	
		Select Case UCase((Mid(this_name,1,1)))
			Case "R"
				the_count = rcount
				rcount = rcount +1
			Case "C" 
				the_count = ccount
				ccount = ccount + 1
			Case "U"
				the_count = ucount
				ucount = ucount + 1
			Case "L"
				the_count = lcount
				lcount = lcount + 1
			Case "D"
				the_count = dcount
				dcount = dcount + 1
		End Select
		
		new_name = Mid(this_name,1,1) & the_count+1
		
 		Let comps.Item(i).Name = new_name
 		
	Next i
	
	ActiveDocument.ActiveView.Refresh

End Sub
